﻿//BS"D
//Cycle Case
//An InDesign script (c) Ariel Walden, 2011; revised 2014
//Freebie script from http://www.Id-Extras.com
try{
mySelection  = app.selection[0];
// If selection is insertionPoint, get word associated with that insertionPoint
if (mySelection instanceof InsertionPoint){
// Simple case: insertionPoint is in middle of word
if (mySelection.words[0].isValid) mySelection = mySelection.words[0];
else{
myIndex = mySelection.index;
// More complicated: insertionPoint is to the left of a word
if (mySelection.parent.insertionPoints[myIndex+1].words[0].isValid) mySelection = mySelection.parent.insertionPoints[myIndex+1].words[0];
else {
// insertionPoint is to the right of a word
mySelection = mySelection.parent.insertionPoints[myIndex-1].words[0];
}
}
}
myText = mySelection.contents;
switch (myText){
// If uppercase, change to lowercase
case myText.toUpperCase(): mySelection.changecase(ChangecaseMode.LOWERCASE); break;
// if lowercase, change to sentencecase
case myText.toLowerCase(): mySelection.changecase(ChangecaseMode.SENTENCECASE);
// sometimes, switching to sentencecase achieves nothing (e.g., if selected word is in middle of sentence), so only break if something has changed
if (mySelection.contents != myText) break;
// no direct javascript way to check for sentencecase, so divide string into two and check. Also, switch to titlecase if we're still in lowercase in middle of sentence
case (myText[0].toUpperCase() + myText.substr(1).toLowerCase() || myText.toLowerCase()):
// if sentencecase change to titlecase
mySelection.changecase(ChangecaseMode.TITLECASE);
// but sometimes, sentencecase and titlecase are identical. If that is not the case, we're okay, since we've changed something, so the cycling will continue, so break
if (mySelection.contents != myText) break;
// ... if we're here, it means that the current text wasn't any predefined mode (e.g. "aBcdE"), or that changing to titlecase from sentencecase achieved nothing, so start the cycle by switch to uppercase
default: mySelection.changecase(ChangecaseMode.UPPERCASE);
}
}
catch(_){}